"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerRequestContextProviders = exports.registerSchema = exports.registerLogger = exports.registerAppBuilder = void 0;

const tsyringe_1 = require("tsyringe");

const __1 = require("..");

function registerAppBuilder(ctx = tsyringe_1.container) {
  ctx.register(__1.BaseInjectorNames.AppBuilder, {
    useClass: __1.AppBuilder
  });
}

exports.registerAppBuilder = registerAppBuilder;

function registerLogger(ctx = tsyringe_1.container) {
  ctx.register(__1.BaseInjectorNames.Logger, {
    useValue: ctx.resolve(__1.LoggerProvider).get()
  });
}

exports.registerLogger = registerLogger;

function registerSchema(schema, ctx = tsyringe_1.container) {
  ctx.register(__1.BaseInjectorNames.Schema, {
    useValue: schema
  });
}

exports.registerSchema = registerSchema;

function registerRequestContextProviders(
/* eslint-disable-next-line @typescript-eslint/no-explicit-any */
providers, ctx) {
  ctx.register(__1.BaseInjectorNames.RequestContextProviders, {
    useValue: providers
  });
}

exports.registerRequestContextProviders = registerRequestContextProviders;