"use strict";

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

var __metadata = this && this.__metadata || function (k, v) {
  if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};

var __param = this && this.__param || function (paramIndex, decorator) {
  return function (target, key) {
    decorator(target, key, paramIndex);
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Server = void 0;

const tsyringe_1 = require("tsyringe");

const app_1 = require("../app");

const injectors_1 = require("../injectors");

let Server = class Server {
  constructor(_configuration, _appBuilder, _logger) {
    this._configuration = _configuration;
    this._appBuilder = _appBuilder;
    this._logger = _logger;
  }

  async start(preRun) {
    try {
      this._logger.info('starting server...');

      await this._appBuilder.start(preRun);

      this._logger.info(`server listening on port ${this._configuration.serverPort}`);
    } catch (err) {
      this._logger.error('error starting app', err);

      throw err;
    }
  }

};
Server = __decorate([(0, tsyringe_1.singleton)(), __param(0, (0, tsyringe_1.inject)(injectors_1.BaseInjectorNames.Configuration)), __param(1, (0, tsyringe_1.inject)(injectors_1.BaseInjectorNames.AppBuilder)), __param(2, (0, tsyringe_1.inject)(injectors_1.BaseInjectorNames.Logger)), __metadata("design:paramtypes", [Object, app_1.AppBuilder, Object])], Server);
exports.Server = Server;