"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IdentityRequestContextProvider = exports.stripBearerPrefix = void 0;

const stripBearerPrefix = header => header == null ? null : header.indexOf('Bearer ') === 0 ? header.slice('Bearer '.length) : header;

exports.stripBearerPrefix = stripBearerPrefix;

class IdentityRequestContextProvider {
  constructor(headerName = 'authorization', headerTransformer = exports.stripBearerPrefix) {
    this._headerTransformer = headerTransformer;
    this._headerName = headerName;
  }

  async apply(ctx, request) {
    var _request$headers$this;

    const {
      authenticator
    } = ctx.components;

    const token = this._headerTransformer((_request$headers$this = request.headers[this._headerName]) !== null && _request$headers$this !== void 0 ? _request$headers$this : null);

    const identity = await authenticator.verifyToken(token);
    return {
      identity
    };
  }

}

exports.IdentityRequestContextProvider = IdentityRequestContextProvider;